Draft "Кривая Безье"

From FreeCAD Documentation
Revision as of 13:15, 5 October 2021 by FuzzyBot (talk | contribs) (Updating to match new version of source page)

Draft BezCurve

Системное название
Draft BezCurve
Расположение в меню
Черчение → Кривая Безье
Верстаки
Draft, Arch
Быстрые клавиши
B Z
Представлено в версии
-
См. также
Нет

Описание

Средство BezCurve создает Bezier Curve (или кусочную кривую Безье) из нескольких точек текущей work plane. Он берет linewidth and color , предварительно установленный на вкладке «Задачи».

Объект создается как одна кривая Безье степени (number_of_points - 1). Это можно изменить на кусочную кривую Безье определенной степени после создания с помощью properties editor. Кривые Безье можно редактировать с помощью Draft Edit.

The Draft BezCurve and the Draft CubicBezCurve commands use control points to define the position and curvature of the spline. The Draft BSpline command, on the other hand, specifies the exact points through which the curve will pass.

Bézier curve defined by multiple points

Применение

See also: Draft Tray, Draft Snap and Draft Constrain.

  1. There are several ways to invoke the command:
  2. The Bézier curve task panel opens. See Options for more information.
  3. Pick the first point in the 3D view, or type coordinates and press the Enter point button.
  4. Pick additional points in the 3D view, or type coordinates and press the Enter point button.
  5. Press Esc or the Close button to finish the command.

Опции

The single character keyboard shortcuts available in the task panel can be changed. See Draft Preferences. The shortcuts mentioned here are the default shortcuts.

  • To manually enter coordinates enter the X, Y and Z component, and press Enter after each. Or you can press the Enter point button when you have the desired values. It is advisable to move the pointer out of the 3D view before entering coordinates.
  • Press R or click the Relative checkbox to toggle relative mode. If relative mode is on, coordinates are relative to the last point, if available, else they are relative to the coordinate system origin.
  • Press G or click the Global checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the working plane coordinate system. introduced in version 0.20
  • Press L or click the Filled checkbox to toggle filled mode. If filled mode is on, the created curve will have ДанныеMake Face set to true and will have a filled face, provided it is closed and does not self-intersect. Note that a self-intersecting curve with a face will not display properly, for such a curve ДанныеMake Face must be set to false.
  • Press T or click the Continue checkbox to toggle continue mode. If continue mode is on, the command will restart after using Finish or Close, or after creating a closed curve by snapping to the first point of the curve, allowing you to continue creating curves.
  • Press the Undo button to undo the last point. The Ctrl+Z keyboard shortcut currently does not work.
  • Press A or the Finish button to finish the command and leave the curve open.
  • Press O or the Close button to finish the command and close the curve. A closed curve can also be created by snapping to the first point of the curve.
  • Press W or the Wipe button to delete the segments already placed, but keep working from the last point.
  • Press U or the Set WP button to adjust the current working plane in the orientation defined by the last and the previous point.
  • Press S to switch Draft snapping on or off.
  • Press Esc or the Close button to finish the command.

Примечания

  • A Draft BezCurve can be edited with the Draft Edit command.
  • OpenCascade, and therefore FreeCAD, does not support Bézier curves of degrees larger than 25. This should not be a problem in practice, as most users typically use Bézier curves of degrees 3 to 5.

Настройки

See also: Preferences Editor and Draft Preferences.

  • To change the number of decimals used for the input of coordinates: Edit → Preferences... → General → Units → Units settings → Number of decimals.
  • To change the initial value of filled mode: Edit → Preferences... → Draft → General settings → Draft tools options → Fill objects with faces whenever possible. Changing the filled mode in a task panel will override this preference for the current FreeCAD session.

Свойства

See also: Property editor.

A Draft BezCurve object is derived from a Part Part2DObject and inherits all its properties. It also has the following additional properties:

Данные

Draft

  • ДанныеArea (Area): (read-only) specifies the area of the face of the curve. The value will be 0.0 if ДанныеMake Face if false or the face cannot be created.
  • ДанныеClosed (Bool): specifies if the curve is closed or not. If the curve is initially open this value is false, setting it to true will draw a segment to close the curve. If the curve is initially closed this value is true, setting it to false will remove the last segment and make the curve open.
  • ДанныеContinuity (IntegerList): (read-only) specifies the continuity of the curve.
  • ДанныеDegree (Integer): specifies the degree of the curve.
  • ДанныеLength (Length): (read-only) specifies the total length of the curve.
  • ДанныеMake Face (Bool): specifies if the curve makes a face or not. If it is true a face is created, otherwise only the perimeter is considered part of the object. This property only works if ДанныеClosed is true and if the curve does not self-intersect.
  • ДанныеPoints (VectorList): specifies the control points of the curve in its local coordinate system.

Вид

Draft

  • ВидArrow Size (Length): specifies the size of the symbol displayed at the end of the curve.
  • ВидArrow Type (Enumeration): specifies the type of symbol displayed at the end of the curve, which can be Dot, Circle, Arrow, Tick or Tick-2.
  • ВидEnd Arrow (Bool): specifies whether to show a symbol at the end of the curve, so it can be used as an annotation line.
  • ВидPattern (Enumeration): specifies the Draft Pattern with which to fill the face of the closed curve. This property only works if ДанныеMake Face is true and if ВидDisplay Mode is Flat Lines.
  • ВидPattern Size (Float): specifies the size of the Draft Pattern.

Программирование

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a Draft Line use the make_bezcurve method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeBezCurve method.

bezcurve = make_bezcurve(pointslist, closed=False, placement=None, face=None, support=None, degree=None)
bezcurve = make_bezcurve(Part.Wire, closed=False, placement=None, face=None, support=None, degree=None)
  • Creates a bezcurve object with the given list of points, pointslist.
    • Each point in the list is defined by its FreeCAD.Vector, with units in millimeters.
    • Alternatively, the input can be a Part.Wire, from which points are extracted.
  • If closed is True, or if the first and last points are identical, the curve is closed.
  • If placement is None the curve is created at the origin.
  • If face is True, and the curve is closed, the curve will make a face, that is, it will appear filled.

Пример:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(2000, 0, 0)
p4 = App.Vector(1500, -2000, 0)

bezcurve1 = Draft.make_bezcurve([p1, p2, p3, p4], closed=True)
bezcurve2 = Draft.make_bezcurve([p4, 1.3*p2, p1, 4.1*p3], closed=True)
bezcurve3 = Draft.make_bezcurve([1.7*p3, 1.5*p4, 2.1*p2, p1], closed=True)

doc.recompute()